<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'GenericEntity' => '\\StructType\\GenericEntity',
            'GenericVersioningEntity' => '\\StructType\\GenericVersioningEntity',
            'ListOptions' => '\\StructType\\ListOptions',
            'DateInterval' => '\\StructType\\DateInterval',
            'EntityList' => '\\StructType\\EntityList',
            'FaultInfo' => '\\StructType\\FaultInfo',
            'Error' => '\\StructType\\Error',
            'Application' => '\\StructType\\Application',
            'ApplicationDataWrapper' => '\\StructType\\ApplicationDataWrapper',
            'ApplicationResultWrapper' => '\\StructType\\ApplicationResultWrapper',
            'ApplicationData' => '\\StructType\\ApplicationData',
            'ApplicationResultData' => '\\StructType\\ApplicationResultData',
            'BusinessErrorList' => '\\StructType\\BusinessErrorList',
            'BusinessError' => '\\StructType\\BusinessError',
            'submitApplicationRequest' => '\\StructType\\SubmitApplicationRequest',
            'submitApplicationResponse' => '\\StructType\\SubmitApplicationResponse',
            'receiveApplicationResultRequest' => '\\StructType\\ReceiveApplicationResultRequest',
            'receiveApplicationResultResponse' => '\\StructType\\ReceiveApplicationResultResponse',
            'Purpose' => '\\StructType\\Purpose',
            'Unit' => '\\StructType\\Unit',
            'PackingType' => '\\StructType\\PackingType',
            'PurposeList' => '\\StructType\\PurposeList',
            'UnitList' => '\\StructType\\UnitList',
            'Country' => '\\StructType\\Country',
            'FederalDistrict' => '\\StructType\\FederalDistrict',
            'AddressObjectView' => '\\StructType\\AddressObjectView',
            'Region' => '\\StructType\\Region',
            'District' => '\\StructType\\District',
            'Locality' => '\\StructType\\Locality',
            'Street' => '\\StructType\\Street',
            'Address' => '\\StructType\\Address',
            'CountryList' => '\\StructType\\CountryList',
            'RegionList' => '\\StructType\\RegionList',
            'DistrictList' => '\\StructType\\DistrictList',
            'LocalityList' => '\\StructType\\LocalityList',
            'StreetList' => '\\StructType\\StreetList',
            'Enterprise' => '\\StructType\\Enterprise',
            'EnterpriseActivityList' => '\\StructType\\EnterpriseActivityList',
            'EnterpriseActivity' => '\\StructType\\EnterpriseActivity',
            'Producer' => '\\StructType\\Producer',
            'ProducerList' => '\\StructType\\ProducerList',
            'EnterpriseNumberList' => '\\StructType\\EnterpriseNumberList',
            'EnterpriseList' => '\\StructType\\EnterpriseList',
            'BusinessMember' => '\\StructType\\BusinessMember',
            'BusinessEntity' => '\\StructType\\BusinessEntity',
            'activityLocation' => '\\StructType\\ActivityLocation',
            'IncorporationForm' => '\\StructType\\IncorporationForm',
            'BusinessEntityList' => '\\StructType\\BusinessEntityList',
            'ProductItem' => '\\StructType\\ProductItem',
            'Product' => '\\StructType\\Product',
            'SubProduct' => '\\StructType\\SubProduct',
            'ProductList' => '\\StructType\\ProductList',
            'SubProductList' => '\\StructType\\SubProductList',
            'ProductItemList' => '\\StructType\\ProductItemList',
            'ProductMarks' => '\\StructType\\ProductMarks',
            'Package' => '\\StructType\\Package',
            'PackageList' => '\\StructType\\PackageList',
            'ComplexDate' => '\\StructType\\ComplexDate',
            'ProductItemProducing' => '\\StructType\\ProductItemProducing',
            'Packaging' => '\\StructType\\Packaging',
            'Location' => '\\StructType\\Location',
            'EnterpriseOfficialRegistration' => '\\StructType\\EnterpriseOfficialRegistration',
            'Organization' => '\\StructType\\Organization',
            'Indicator' => '\\StructType\\Indicator',
            'AnimalDisease' => '\\StructType\\AnimalDisease',
            'ResearchMethod' => '\\StructType\\ResearchMethod',
            'MedicinalDrug' => '\\StructType\\MedicinalDrug',
            'RegionalizationCondition' => '\\StructType\\RegionalizationCondition',
            'RegionalizationConditionGroup' => '\\StructType\\RegionalizationConditionGroup',
            'RegionalizationRequirement' => '\\StructType\\RegionalizationRequirement',
            'RegionalizationShippingRule' => '\\StructType\\RegionalizationShippingRule',
            'RegionalizationStatus' => '\\StructType\\RegionalizationStatus',
            'RegionalizationRegionStatus' => '\\StructType\\RegionalizationRegionStatus',
            'Area' => '\\StructType\\Area',
            'RegionalizationConditionList' => '\\StructType\\RegionalizationConditionList',
            'RegionalizationRegionStatusList' => '\\StructType\\RegionalizationRegionStatusList',
            'RegionalizationShippingRuleList' => '\\StructType\\RegionalizationShippingRuleList',
            'AnimalDiseaseList' => '\\StructType\\AnimalDiseaseList',
            'ResearchMethodList' => '\\StructType\\ResearchMethodList',
            'ActivityLocationList' => '\\StructType\\ActivityLocationList',
            'VetDocument' => '\\StructType\\VetDocument',
            'Batch' => '\\StructType\\Batch',
            'Consignment' => '\\StructType\\Consignment',
            'RawBatch' => '\\StructType\\RawBatch',
            'ProductiveBatch' => '\\StructType\\ProductiveBatch',
            'Delivery' => '\\StructType\\Delivery',
            'DeliveryFactList' => '\\StructType\\DeliveryFactList',
            'DeliveryInspection' => '\\StructType\\DeliveryInspection',
            'ConsignmentDocumentList' => '\\StructType\\ConsignmentDocumentList',
            'GoodsDate' => '\\StructType\\GoodsDate',
            'VetDocumentList' => '\\StructType\\VetDocumentList',
            'DiscrepancyReport' => '\\StructType\\DiscrepancyReport',
            'DiscrepancyReason' => '\\StructType\\DiscrepancyReason',
            'StockEntry' => '\\StructType\\StockEntry',
            'StockEntryList' => '\\StructType\\StockEntryList',
            'StockDiscrepancy' => '\\StructType\\StockDiscrepancy',
            'StockEntrySearchPattern' => '\\StructType\\StockEntrySearchPattern',
            'Document' => '\\StructType\\Document',
            'Waybill' => '\\StructType\\Waybill',
            'TransportInfo' => '\\StructType\\TransportInfo',
            'TransportNumber' => '\\StructType\\TransportNumber',
            'ShipmentRoutePoint' => '\\StructType\\ShipmentRoutePoint',
            'ShipmentRoute' => '\\StructType\\ShipmentRoute',
            'ProductionOperation' => '\\StructType\\ProductionOperation',
            'MergeStockEntriesOperation' => '\\StructType\\MergeStockEntriesOperation',
            'PSLModificationOperation' => '\\StructType\\PSLModificationOperation',
            'BEModificationOperation' => '\\StructType\\BEModificationOperation',
            'BEActivityLocationsModificationOperation' => '\\StructType\\BEActivityLocationsModificationOperation',
            'ENTModificationOperation' => '\\StructType\\ENTModificationOperation',
            'CertifiedBatch' => '\\StructType\\CertifiedBatch',
            'CertifiedConsignment' => '\\StructType\\CertifiedConsignment',
            'ReferencedDocument' => '\\StructType\\ReferencedDocument',
            'VeterinaryEvent' => '\\StructType\\VeterinaryEvent',
            'LaboratoryResearchEvent' => '\\StructType\\LaboratoryResearchEvent',
            'AnimalMedicationEvent' => '\\StructType\\AnimalMedicationEvent',
            'QuarantineEvent' => '\\StructType\\QuarantineEvent',
            'VeterinaryAuthentication' => '\\StructType\\VeterinaryAuthentication',
            'BatchOrigin' => '\\StructType\\BatchOrigin',
            'BatchExtraInfo' => '\\StructType\\BatchExtraInfo',
            'StockEntryEventList' => '\\StructType\\StockEntryEventList',
            'VetDocumentStatusChange' => '\\StructType\\VetDocumentStatusChange',
            'RegionalizationClause' => '\\StructType\\RegionalizationClause',
            'RouteSectionR13nRules' => '\\StructType\\RouteSectionR13nRules',
            'ProcessingProcedure' => '\\StructType\\ProcessingProcedure',
            'User' => '\\StructType\\User',
            'UserList' => '\\StructType\\UserList',
            'AuthorityList' => '\\StructType\\AuthorityList',
            'WorkingAreaList' => '\\StructType\\WorkingAreaList',
            'UserAuthority' => '\\StructType\\UserAuthority',
            'WorkingArea' => '\\StructType\\WorkingArea',
            'Citizenship' => '\\StructType\\Citizenship',
            'MercuryApplicationRequest' => '\\StructType\\MercuryApplicationRequest',
            'ProcessIncomingConsignmentRequest' => '\\StructType\\ProcessIncomingConsignmentRequest',
            'ProcessIncomingConsignmentResponse' => '\\StructType\\ProcessIncomingConsignmentResponse',
            'ProcessIncomingDeliveryRequest' => '\\StructType\\ProcessIncomingDeliveryRequest',
            'ProcessIncomingDeliveryResponse' => '\\StructType\\ProcessIncomingDeliveryResponse',
            'PrepareOutgoingConsignmentRequest' => '\\StructType\\PrepareOutgoingConsignmentRequest',
            'PrepareOutgoingConsignmentResponse' => '\\StructType\\PrepareOutgoingConsignmentResponse',
            'RegisterProductionOperationRequest' => '\\StructType\\RegisterProductionOperationRequest',
            'RegisterProductionOperationResponse' => '\\StructType\\RegisterProductionOperationResponse',
            'MergeStockEntriesRequest' => '\\StructType\\MergeStockEntriesRequest',
            'MergeStockEntriesResponse' => '\\StructType\\MergeStockEntriesResponse',
            'WithdrawVetDocumentRequest' => '\\StructType\\WithdrawVetDocumentRequest',
            'WithdrawVetDocumentResponse' => '\\StructType\\WithdrawVetDocumentResponse',
            'ModifyBusinessEntityRequest' => '\\StructType\\ModifyBusinessEntityRequest',
            'ModifyBusinessEntityResponse' => '\\StructType\\ModifyBusinessEntityResponse',
            'ModifyEnterpriseRequest' => '\\StructType\\ModifyEnterpriseRequest',
            'ModifyEnterpriseResponse' => '\\StructType\\ModifyEnterpriseResponse',
            'ModifyActivityLocationsRequest' => '\\StructType\\ModifyActivityLocationsRequest',
            'ModifyActivityLocationsResponse' => '\\StructType\\ModifyActivityLocationsResponse',
            'ResolveDiscrepancyRequest' => '\\StructType\\ResolveDiscrepancyRequest',
            'ResolveDiscrepancyResponse' => '\\StructType\\ResolveDiscrepancyResponse',
            'ModifyProducerStockListRequest' => '\\StructType\\ModifyProducerStockListRequest',
            'ModifyProducerStockListResponse' => '\\StructType\\ModifyProducerStockListResponse',
            'GetVetDocumentByUuidRequest' => '\\StructType\\GetVetDocumentByUuidRequest',
            'GetVetDocumentByUuidResponse' => '\\StructType\\GetVetDocumentByUuidResponse',
            'GetVetDocumentListRequest' => '\\StructType\\GetVetDocumentListRequest',
            'GetVetDocumentListResponse' => '\\StructType\\GetVetDocumentListResponse',
            'GetVetDocumentChangesListRequest' => '\\StructType\\GetVetDocumentChangesListRequest',
            'GetVetDocumentChangesListResponse' => '\\StructType\\GetVetDocumentChangesListResponse',
            'GetStockEntryByGuidRequest' => '\\StructType\\GetStockEntryByGuidRequest',
            'GetStockEntryByGuidResponse' => '\\StructType\\GetStockEntryByGuidResponse',
            'GetStockEntryByUuidRequest' => '\\StructType\\GetStockEntryByUuidRequest',
            'GetStockEntryByUuidResponse' => '\\StructType\\GetStockEntryByUuidResponse',
            'GetStockEntryChangesListRequest' => '\\StructType\\GetStockEntryChangesListRequest',
            'GetStockEntryChangesListResponse' => '\\StructType\\GetStockEntryChangesListResponse',
            'GetStockEntryListRequest' => '\\StructType\\GetStockEntryListRequest',
            'GetStockEntryListResponse' => '\\StructType\\GetStockEntryListResponse',
            'GetStockEntryVersionListRequest' => '\\StructType\\GetStockEntryVersionListRequest',
            'GetStockEntryVersionListResponse' => '\\StructType\\GetStockEntryVersionListResponse',
            'UpdateTransportMovementDetailsRequest' => '\\StructType\\UpdateTransportMovementDetailsRequest',
            'UpdateTransportMovementDetailsResponse' => '\\StructType\\UpdateTransportMovementDetailsResponse',
            'UpdateVeterinaryEventsRequest' => '\\StructType\\UpdateVeterinaryEventsRequest',
            'UpdateVeterinaryEventsResponse' => '\\StructType\\UpdateVeterinaryEventsResponse',
            'CheckShipmentRegionalizationRequest' => '\\StructType\\CheckShipmentRegionalizationRequest',
            'CheckShipmentRegionalizationResponse' => '\\StructType\\CheckShipmentRegionalizationResponse',
            'AddBusinessEntityUserRequest' => '\\StructType\\AddBusinessEntityUserRequest',
            'AddBusinessEntityUserResponse' => '\\StructType\\AddBusinessEntityUserResponse',
            'GetBusinessEntityUserListRequest' => '\\StructType\\GetBusinessEntityUserListRequest',
            'GetBusinessEntityUserListResponse' => '\\StructType\\GetBusinessEntityUserListResponse',
            'GetBusinessEntityUserRequest' => '\\StructType\\GetBusinessEntityUserRequest',
            'GetBusinessEntityUserResponse' => '\\StructType\\GetBusinessEntityUserResponse',
            'UpdateUserAuthoritiesRequest' => '\\StructType\\UpdateUserAuthoritiesRequest',
            'UpdateUserAuthoritiesResponse' => '\\StructType\\UpdateUserAuthoritiesResponse',
            'UpdateUserWorkingAreasRequest' => '\\StructType\\UpdateUserWorkingAreasRequest',
            'UpdateUserWorkingAreasResponse' => '\\StructType\\UpdateUserWorkingAreasResponse',
            'UnbindBusinessEntityUserRequest' => '\\StructType\\UnbindBusinessEntityUserRequest',
            'UnbindBusinessEntityUserResponse' => '\\StructType\\UnbindBusinessEntityUserResponse',
            'GetApplicableUserAuthorityListRequest' => '\\StructType\\GetApplicableUserAuthorityListRequest',
            'GetApplicableUserAuthorityListResponse' => '\\StructType\\GetApplicableUserAuthorityListResponse',
        );
    }
}
