<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Citizenship StructType
 * Meta informations extracted from the WSDL
 * - documentation: Тип, описывающий гражданство.
 * @subpackage Structs
 */
class Citizenship extends AbstractStructBase
{
    /**
     * The country
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Country
     */
    public $country;
    /**
     * Constructor method for Citizenship
     * @uses Citizenship::setCountry()
     * @param \StructType\Country $country
     */
    public function __construct(\StructType\Country $country = null)
    {
        $this
            ->setCountry($country);
    }
    /**
     * Get country value
     * @return \StructType\Country|null
     */
    public function getCountry()
    {
        return $this->country;
    }
    /**
     * Set country value
     * @param \StructType\Country $country
     * @return \StructType\Citizenship
     */
    public function setCountry(\StructType\Country $country = null)
    {
        $this->country = $country;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Citizenship
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
