<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetBusinessEntityUserRequest StructType
 * Meta informations extracted from the WSDL
 * - documentation: Запрос на получение полных сведений о пользователе ХС-заявителя. Пользователь должен быть привязан к ХС-заявителю, иначе --
 * ошибка. | Пользователь, для которого запрашиваются сведения. Должен быть указан uuid или login.
 * @subpackage Structs
 */
class GetBusinessEntityUserRequest extends MercuryApplicationRequest
{
    /**
     * The user
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - ref: vd:user
     * @var \StructType\User
     */
    public $user;
    /**
     * Constructor method for GetBusinessEntityUserRequest
     * @uses GetBusinessEntityUserRequest::setUser()
     * @param \StructType\User $user
     */
    public function __construct(\StructType\User $user = null)
    {
        $this
            ->setUser($user);
    }
    /**
     * Get user value
     * @return \StructType\User
     */
    public function getUser()
    {
        return $this->user;
    }
    /**
     * Set user value
     * @param \StructType\User $user
     * @return \StructType\GetBusinessEntityUserRequest
     */
    public function setUser(\StructType\User $user = null)
    {
        $this->user = $user;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetBusinessEntityUserRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
