<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ModifyActivityLocationsResponse StructType
 * Meta informations extracted from the WSDL
 * - documentation: Результат заявки на изменение списка мест осуществления деятельности хозяйствующим субъектом.
 * @subpackage Structs
 */
class ModifyActivityLocationsResponse extends ApplicationResultData
{
    /**
     * The businessEntity
     * Meta informations extracted from the WSDL
     * - documentation: Запись хозяйствующего субъекта с указанием текущего списка площадок.
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\BusinessEntity
     */
    public $businessEntity;
    /**
     * Constructor method for ModifyActivityLocationsResponse
     * @uses ModifyActivityLocationsResponse::setBusinessEntity()
     * @param \StructType\BusinessEntity $businessEntity
     */
    public function __construct(\StructType\BusinessEntity $businessEntity = null)
    {
        $this
            ->setBusinessEntity($businessEntity);
    }
    /**
     * Get businessEntity value
     * @return \StructType\BusinessEntity|null
     */
    public function getBusinessEntity()
    {
        return $this->businessEntity;
    }
    /**
     * Set businessEntity value
     * @param \StructType\BusinessEntity $businessEntity
     * @return \StructType\ModifyActivityLocationsResponse
     */
    public function setBusinessEntity(\StructType\BusinessEntity $businessEntity = null)
    {
        $this->businessEntity = $businessEntity;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ModifyActivityLocationsResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
