<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ModifyEnterpriseRequest StructType
 * Meta informations extracted from the WSDL
 * - documentation: Заявка на внесение изменений в реестр предприятий.
 * @subpackage Structs
 */
class ModifyEnterpriseRequest extends MercuryApplicationRequest
{
    /**
     * The modificationOperation
     * Meta informations extracted from the WSDL
     * - documentation: Операция внесения изменений в реестр предприятий.
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\ENTModificationOperation
     */
    public $modificationOperation;
    /**
     * Constructor method for ModifyEnterpriseRequest
     * @uses ModifyEnterpriseRequest::setModificationOperation()
     * @param \StructType\ENTModificationOperation $modificationOperation
     */
    public function __construct(\StructType\ENTModificationOperation $modificationOperation = null)
    {
        $this
            ->setModificationOperation($modificationOperation);
    }
    /**
     * Get modificationOperation value
     * @return \StructType\ENTModificationOperation
     */
    public function getModificationOperation()
    {
        return $this->modificationOperation;
    }
    /**
     * Set modificationOperation value
     * @param \StructType\ENTModificationOperation $modificationOperation
     * @return \StructType\ModifyEnterpriseRequest
     */
    public function setModificationOperation(\StructType\ENTModificationOperation $modificationOperation = null)
    {
        $this->modificationOperation = $modificationOperation;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ModifyEnterpriseRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
