<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ProductItemProducing StructType
 * Meta informations extracted from the WSDL
 * - documentation: Тип, описывающий выпуск номенклатурной позиции на предприятии.
 * @subpackage Structs
 */
class ProductItemProducing extends AbstractStructBase
{
    /**
     * The location
     * Meta informations extracted from the WSDL
     * - documentation: Площадка, осуществляющая выпуск продукции.
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\Enterprise
     */
    public $location;
    /**
     * Constructor method for ProductItemProducing
     * @uses ProductItemProducing::setLocation()
     * @param \StructType\Enterprise $location
     */
    public function __construct(\StructType\Enterprise $location = null)
    {
        $this
            ->setLocation($location);
    }
    /**
     * Get location value
     * @return \StructType\Enterprise
     */
    public function getLocation()
    {
        return $this->location;
    }
    /**
     * Set location value
     * @param \StructType\Enterprise $location
     * @return \StructType\ProductItemProducing
     */
    public function setLocation(\StructType\Enterprise $location = null)
    {
        $this->location = $location;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ProductItemProducing
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
