<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RegionalizationRegionStatusList StructType
 * Meta informations extracted from the WSDL
 * - documentation: Тип, описывающий список статусов региона (регионализация).
 * @subpackage Structs
 */
class RegionalizationRegionStatusList extends EntityList
{
    /**
     * The status
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\RegionalizationRegionStatus[]
     */
    public $status;
    /**
     * Constructor method for RegionalizationRegionStatusList
     * @uses RegionalizationRegionStatusList::setStatus()
     * @param \StructType\RegionalizationRegionStatus[] $status
     */
    public function __construct(array $status = array())
    {
        $this
            ->setStatus($status);
    }
    /**
     * Get status value
     * @return \StructType\RegionalizationRegionStatus[]|null
     */
    public function getStatus()
    {
        return $this->status;
    }
    /**
     * Set status value
     * @throws \InvalidArgumentException
     * @param \StructType\RegionalizationRegionStatus[] $status
     * @return \StructType\RegionalizationRegionStatusList
     */
    public function setStatus(array $status = array())
    {
        foreach ($status as $regionalizationRegionStatusListStatusItem) {
            // validation for constraint: itemType
            if (!$regionalizationRegionStatusListStatusItem instanceof \StructType\RegionalizationRegionStatus) {
                throw new \InvalidArgumentException(sprintf('The status property can only contain items of \StructType\RegionalizationRegionStatus, "%s" given', is_object($regionalizationRegionStatusListStatusItem) ? get_class($regionalizationRegionStatusListStatusItem) : gettype($regionalizationRegionStatusListStatusItem)), __LINE__);
            }
        }
        $this->status = $status;
        return $this;
    }
    /**
     * Add item to status value
     * @throws \InvalidArgumentException
     * @param \StructType\RegionalizationRegionStatus $item
     * @return \StructType\RegionalizationRegionStatusList
     */
    public function addToStatus(\StructType\RegionalizationRegionStatus $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\RegionalizationRegionStatus) {
            throw new \InvalidArgumentException(sprintf('The status property can only contain items of \StructType\RegionalizationRegionStatus, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->status[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\RegionalizationRegionStatusList
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
