<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UpdateTransportMovementDetailsResponse StructType
 * Meta informations extracted from the WSDL
 * - documentation: Результат заявки на получение списка версий записи журнала. | Список транспортных ветеринарных сертификатов с измененными
 * сведениями о транспортных средствах.
 * @subpackage Structs
 */
class UpdateTransportMovementDetailsResponse extends ApplicationResultData
{
    /**
     * The vetDocument
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - ref: vd:vetDocument
     * @var \StructType\VetDocument[]
     */
    public $vetDocument;
    /**
     * Constructor method for UpdateTransportMovementDetailsResponse
     * @uses UpdateTransportMovementDetailsResponse::setVetDocument()
     * @param \StructType\VetDocument[] $vetDocument
     */
    public function __construct(array $vetDocument = array())
    {
        $this
            ->setVetDocument($vetDocument);
    }
    /**
     * Get vetDocument value
     * @return \StructType\VetDocument[]|null
     */
    public function getVetDocument()
    {
        return $this->vetDocument;
    }
    /**
     * Set vetDocument value
     * @throws \InvalidArgumentException
     * @param \StructType\VetDocument[] $vetDocument
     * @return \StructType\UpdateTransportMovementDetailsResponse
     */
    public function setVetDocument(array $vetDocument = array())
    {
        foreach ($vetDocument as $updateTransportMovementDetailsResponseVetDocumentItem) {
            // validation for constraint: itemType
            if (!$updateTransportMovementDetailsResponseVetDocumentItem instanceof \StructType\VetDocument) {
                throw new \InvalidArgumentException(sprintf('The vetDocument property can only contain items of \StructType\VetDocument, "%s" given', is_object($updateTransportMovementDetailsResponseVetDocumentItem) ? get_class($updateTransportMovementDetailsResponseVetDocumentItem) : gettype($updateTransportMovementDetailsResponseVetDocumentItem)), __LINE__);
            }
        }
        $this->vetDocument = $vetDocument;
        return $this;
    }
    /**
     * Add item to vetDocument value
     * @throws \InvalidArgumentException
     * @param \StructType\VetDocument $item
     * @return \StructType\UpdateTransportMovementDetailsResponse
     */
    public function addToVetDocument(\StructType\VetDocument $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\VetDocument) {
            throw new \InvalidArgumentException(sprintf('The vetDocument property can only contain items of \StructType\VetDocument, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->vetDocument[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\UpdateTransportMovementDetailsResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
