<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for WorkingArea StructType
 * Meta informations extracted from the WSDL
 * - documentation: Тип, описывающий список зон обслуживания.
 * @subpackage Structs
 */
class WorkingArea extends AbstractStructBase
{
    /**
     * The area
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Area
     */
    public $area;
    /**
     * The enterprise
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Enterprise
     */
    public $enterprise;
    /**
     * Constructor method for WorkingArea
     * @uses WorkingArea::setArea()
     * @uses WorkingArea::setEnterprise()
     * @param \StructType\Area $area
     * @param \StructType\Enterprise $enterprise
     */
    public function __construct(\StructType\Area $area = null, \StructType\Enterprise $enterprise = null)
    {
        $this
            ->setArea($area)
            ->setEnterprise($enterprise);
    }
    /**
     * Get area value
     * @return \StructType\Area|null
     */
    public function getArea()
    {
        return $this->area;
    }
    /**
     * Set area value
     * @param \StructType\Area $area
     * @return \StructType\WorkingArea
     */
    public function setArea(\StructType\Area $area = null)
    {
        $this->area = $area;
        return $this;
    }
    /**
     * Get enterprise value
     * @return \StructType\Enterprise|null
     */
    public function getEnterprise()
    {
        return $this->enterprise;
    }
    /**
     * Set enterprise value
     * @param \StructType\Enterprise $enterprise
     * @return \StructType\WorkingArea
     */
    public function setEnterprise(\StructType\Enterprise $enterprise = null)
    {
        $this->enterprise = $enterprise;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\WorkingArea
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
